// score:100
#include <bits/stdc++.h>
using namespace std;

constexpr int inf = 1e9;

vector<array<vector<int>, 2> > g;

signed main(){
	int n, m, l, s, t, k;
	assert(cin >> n >> m >> l >> k >> s >> t);
	assert(0<=s && s<n && 0<=t && t<n);
	g.resize(n);
	for(int it=0;it<2;++it){
		for(int i=0;i<(it==0?m:l);++i){
			int a, b;
			assert(cin >> a >> b);
			assert(0<=a && a<n && 0<=b && b<n);
			g[a][it].push_back(b);
		}
	}
	vector<vector<int> > dist(n, vector<int>(k+1, inf));
	queue<pair<int, int> > q;
	dist[s][0] = 0;
	q.emplace(s, 0);
	while(!q.empty()){
		int v, d;
		tie(v, d) = q.front(); q.pop();
		for(int it=0;it<=min(1, k-d);++it){
			for(auto &e:g[v][it]){
				if(dist[e][d+it] == inf){
					dist[e][d+it] = dist[v][d]+(it==0);
					q.emplace(e, d+it);
				}
			}
		}
	}
	if(dist[t][k] == inf){
		cout << "-1\n";
	} else {
		cout << dist[t][k] << "\n";
	}
}
